/*
 * Created on 07.08.2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package javaxml;


import java.io.IOException;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Fr Beispiel 2 (SimpleGenericHTTPSoapClient_2)
 * Einfaches Servlet, welches ein empfangenes XML SOAP Dokument liestund analysiert.
 * Im Gegensatz zum Servlet SimpleHTTPReceive aus dem Beispiel 1 kann dieses Servlet (Beispiel 2) 
 * das SOAP Dokument analysieren!
 *  * @author jjoller
 *
 */

public class HTTPReceive extends HttpServlet
{
	public void doGet(HttpServletRequest request, HttpServletResponse response)
		throws IOException, ServletException
	{
		response.getWriter().print("JAVAXML3/servlet/javaxml.HTTPReceive");
		System.out.println("[HTTPReceive]doGet()");
		response.setStatus(HttpServletResponse.SC_BAD_REQUEST);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
		throws IOException, ServletException
	{
		System.out.println("[HTTPReceive]doPost()");
		System.out.println("____________________________");
		System.out.println("Received request.");
		System.out.println("____________________________");

		// Traverse the HTTP headers and show them on the screen
		System.out.println("[HTTPReceive.doPost]getHeader()");
		for(Enumeration enum = request.getHeaderNames();
		  enum.hasMoreElements(); ){
			String header = (String)enum.nextElement();
			String value  = request.getHeader(header);

			System.out.println("  " + header + " = " + value);
		}

		System.out.println("____________________________");

		if(request.getContentLength() > 0)
		{
			try
			{
				System.out.println("[HTTPReceive.doPost]BufferedReader()");
				java.io.BufferedReader reader = request.getReader();

				// get the document builder
				System.out.println("[HTTPReceive.doPost]xml.parsers.DocumentBuilder()");
				javax.xml.parsers.DocumentBuilder xdb =
					org.apache.soap.util.xml.XMLParserUtils.getXMLDocBuilder();

				// parse it into a DOM
				System.out.println("[HTTPReceive.doPost]dom.Document()");
				org.w3c.dom.Document doc =
					xdb.parse (new org.xml.sax.InputSource (reader));
				if (doc == null)
				{
					// Error occured
					System.out.println("Doc is null!");
					throw new org.apache.soap.SOAPException
						(org.apache.soap.Constants.FAULT_CODE_CLIENT, "parsing error");
				}
				else
				{
					// call static method to create the envelope from the document
					System.out.println("[HTTPReceive.doPost]soap.Envelope()");
					org.apache.soap.Envelope env =
						org.apache.soap.Envelope.unmarshall(doc.getDocumentElement());

					// Now that we have an envelope, do the inverse of what we did to
					// build this
					System.out.println("[HTTPReceive.doPost]soap.Body()");
					org.apache.soap.Body body = env.getBody();
					System.out.println("[HTTPReceive.doPost]body.getBodyEntries()");
					java.util.Vector bodyEntries = body.getBodyEntries();

					System.out.println("[HTTPReceive.doPost]StringWriter()");
					java.io.StringWriter writer = new java.io.StringWriter();

					System.out.println("[HTTPReceive.doPost]xml.DOM2Writer.serializeAsXML()");
					for (java.util.Enumeration e = bodyEntries.elements(); e.hasMoreElements();)
					{
						org.w3c.dom.Element el = (org.w3c.dom.Element)e.nextElement();
						org.apache.soap.util.xml.DOM2Writer.serializeAsXML((org.w3c.dom.Node)el, writer);
					}
					System.out.println(writer.toString());
				}
			}
			catch(Exception e)
			{
				System.out.println(e);
			}
		}

		System.out.println("____________________________");

		response.setContentType("text/xml"); // Need this to prevent Apache SOAP from gacking
	}
}


