/*
 * Created on 03.08.2003
 *
 * To change the template for this generated file go to
 * Dieses Beispiel verwendet Apache XML-RPC. Die Jars mssen im CLASSPATH sein
 */
package javaxml;
	/**
	 * Beispiele zu Kapitel 3 des Skripts zu XML und Java
	 */
import java.math.BigInteger;
import org.apache.xmlrpc.WebServer;

/**
 * <p>Title: Java und XML</p>
 * <p>Description: Kapitel 3</p>
 * @author jjoller
 *	@version 1.0
 */
public class XMLRPCPrimeServer {
	/**
	 * @author jjoller
	 * @version 1.0
	 * @param i Zahl, zu der eine Primzahl (>=) gesucht wird
	 * @param debug, steuert die Ausgabe in der Methode  
	 * @return i Primzahl, die >= der Eingabe ist
	 */

	public int getPrime(int i, boolean debug) {
		System.out.println(
			"[PrimzahlServlet]getPrime(" + i + "," + debug + ")");
		// solange i keine Primzahl ist, addiere 1
		while (!BigInteger.valueOf(i).isProbablePrime(20)) {
			if (debug)
				System.out.println("Primzahlsuche : " + BigInteger.valueOf(i));
			i++;
		}
		// wahrscheinlich ist i jetzt Primzahl
		// (mit Wahrscheinlichkeit 1- 1/(2^20) ~= 1 zu einer Million)
		return i;
	}

	public static void main(String[] args) {
		System.out.println("[XMLRPCPrimeServer]main()");
		try {
   			WebServer server = new WebServer(8080);
			server.addHandler("primeServer", new XMLRPCPrimeServer());

		} catch (Exception exception) {
			System.err.println("[XMLRPCPrimeServer]" + exception.toString());
		}
		
	}
}
