package kapitel03;

/**
 * <p>Title: Java und XML</p>
 * <p>Description: Kapitel 3</p>
 * <p>Copyright: Copyright (c) 2003/4</p>
 * <p>Company: HSR</p>
 * @author J.M.Joller
 * @version 1.0
 */

import java.math.*;
import java.util.*;
import java.io.*;

public class PrimZahlXML {
  private final String PRIM_START_TAG = "<PrimZahlen>"; // Root
  private final String PRIM_END_TAG = "</PrimZahlen>";

  private final String P_START_TAG = "<primzahl>";
  private final String P_END_TAG = "</primzahl>";

  private final static String XML_DECLARATION = "<?xml version=\"1.0\"?>";


    public int getPrime(int i, boolean debug) {
        // solange i keine Primzahl ist, addiere 1
        while (!BigInteger.valueOf(i).isProbablePrime(20)) {
          if (debug) System.out.println("Primzahlsuche : "+BigInteger.valueOf(i));
          i++;
        }
        // wahrscheinlich ist i jetzt Primzahl
        // (mit Wahrscheinlichkeit 1- 1/(2^20) ~= 1 zu einer Million)
        return i;
    }

    public static void main(String[] args) {
      PrimZahlXML prime = new PrimZahlXML();

      // von ... bis
      System.out.println("------------------------------------------------");
      // Set : jede Primzahl soll nur einmal drin stehen
      // Tree : die Primzahlen sollen sortiert sein
      java.util.TreeSet ts = new java.util.TreeSet();
      int iPrime;
      for (int p=2134; p<2200; p++) {
        iPrime=prime.getPrime(p, false);
        //System.err.println("Nchste grssere Primzahl zu "+p+" : "+iPrime);
        ts.add(new Integer(iPrime));
      }

      System.out.println(prime.XML_DECLARATION);
      System.out.println(prime.PRIM_START_TAG);

      Iterator iter = ts.iterator();
      while(iter.hasNext()) {
        System.out.println(prime.P_END_TAG+iter.next()+prime.P_END_TAG);
      }
      System.out.println(prime.PRIM_END_TAG);

      try {
        BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream("Primzahlen.xml"));
        bos.write(prime.XML_DECLARATION.getBytes());
        bos.write(prime.PRIM_START_TAG.getBytes());

        Iterator it = ts.iterator();
        while(it.hasNext()) {
          bos.write((prime.P_START_TAG+it.next()+prime.P_END_TAG).getBytes());
        }
        bos.write(prime.PRIM_END_TAG.getBytes());
        bos.flush();
        bos.close();

      } catch (IOException ioe) {
        ioe.printStackTrace(System.err);
      }
    }

}